## org.apache.poi.hssf.usermodel
Class HSSFRow

    java.lang.Object
      org.apache.poi.hssf.usermodel.HSSFRow

All Implemented Interfaces:
  java.lang.Comparable

public class HSSFRow
extends java.lang.Object
implements java.lang.Comparable

High level representation of a row of a spreadsheet. Only rows that have cells should be added to a Sheet.

Version:
  1.0-pre
Author:
  Andrew C. Oliver (acoliver at apache dot org), Glen Stampoultzis (glens at apache.org)

Field Summary
`static int` `INITIAL_CAPACITY`

Constructor Summary
`protected` `HSSFRow()`
`protected` `HSSFRow(Workbook book, Sheet sheet, int rowNum)` Creates new HSSFRow from scratch.
`protected` `HSSFRow(Workbook book, Sheet sheet, RowRecord record)` Creates an HSSFRow from a low level RowRecord object.

Method Summary
`java.util.Iterator` `cellIterator()`
`int` `compareTo(java.lang.Object obj)`
`HSSFCell` `createCell(short column)` Use this to create new cells within the row and return it.
`HSSFCell` `createCell(short column, int type)` Deprecated. As of 22-Jan-2002 use createCell(short) and use setCellValue to specify the type lazily.
`protected HSSFCell` `createCellFromRecord(CellValueRecordInterface cell)` create a high level HSSFCell object from an existing low level record.
`boolean` `equals(java.lang.Object obj)`
`HSSFCell` `getCell(short cellnum)` get the hssfcell representing a given column (logical cell) 0-based.
`short` `getFirstCellNum()` get the number of the first cell contained in this row.
`short` `getHeight()` get the row's height or ff (-1) for undefined/default-height in twips (1/20th of a point)
`float` `getHeightInPoints()` get the row's height or ff (-1) for undefined/default-height in points (20*getHeight())
`short` `getLastCellNum()` get the number of the last cell contained in this row.
`int` `getPhysicalNumberOfCells()` gets the number of defined cells (NOT number of cells in the actual row!).
`int` `getRowNum()` get row number this row represents
`protected RowRecord` `getRowRecord()` get the lowlevel RowRecord represented by this object - should only be called by other parts of the high level API
`void` `removeCell(HSSFCell cell)` remove the HSSFCell from this row.
`void` `setHeight(short height)` set the row's height or set to ff (-1) for undefined/default-height.
`void` `setHeightInPoints(float height)` set the row's height in points.
`void` `setRowNum(int rowNum)` set the row number of this row.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### INITIAL_CAPACITY

    public static final int INITIAL_CAPACITY

See Also:
  Constant Field Values

Constructor Detail

### HSSFRow

    protected HSSFRow()

### HSSFRow

    protected HSSFRow(Workbook book,
                      Sheet sheet,
                      int rowNum)

  Creates new HSSFRow from scratch. Only HSSFSheet should do this.

Parameters:
  `book` - low-level Workbook object containing the sheet that contains this row
  `sheet` - low-level Sheet object that contains this Row
  `rowNum` - the row number of this row (0 based)
See Also:
  `org.apache.poi.hssf.usermodel.HSSFSheet#createRow(short)`

### HSSFRow

    protected HSSFRow(Workbook book,
                      Sheet sheet,
                      RowRecord record)

  Creates an HSSFRow from a low level RowRecord object. Only HSSFSheet should do this. HSSFSheet uses this when an existing file is read in.

Parameters:
  `book` - low-level Workbook object containing the sheet that contains this row
  `sheet` - low-level Sheet object that contains this Row
  `record` - the low level api object this row should represent
See Also:
  `org.apache.poi.hssf.usermodel.HSSFSheet#createRow(short)`

Method Detail

### createCell

    public HSSFCell createCell(short column)

  Use this to create new cells within the row and return it.

  The cell that is returned is a CELL_TYPE_BLANK. The type can be changed either through calling `setCellValue` or `setCellType`.

  Parameters:
    `column` - - the column number this cell represents
  Returns:
    HSSFCell a high level representation of the created cell.

### createCell

    public HSSFCell createCell(short column,
                               int type)

  Deprecated. As of 22-Jan-2002 use createCell(short) and use setCellValue to specify the type lazily.

  Use this to create new cells within the row and return it.

  The cell that is returned is a CELL_TYPE_BLANK. The type can be changed either through calling setCellValue or setCellType.

  Parameters:
    `column` - - the column number this cell represents
  Returns:
    HSSFCell a high level representation of the created cell.

### removeCell

    public void removeCell(HSSFCell cell)

  remove the HSSFCell from this row.

  Parameters:
    `cell` - to remove

### createCellFromRecord

    protected HSSFCell createCellFromRecord(CellValueRecordInterface cell)

  create a high level HSSFCell object from an existing low level record. Should only be called from HSSFSheet or HSSFRow itself.

  Parameters:
    `cell` - low level cell to create the high level representation from
  Returns:
    HSSFCell representing the low level record passed in

### setRowNum

    public void setRowNum(int rowNum)

  set the row number of this row.

  Parameters:
    `rowNum` - the row number (0-based)

### getRowNum

    public int getRowNum()

  get row number this row represents

  Returns:
    the row number (0 based)

### getCell

    public HSSFCell getCell(short cellnum)

  get the hssfcell representing a given column (logical cell) 0-based. If you ask for a cell that is not defined....you get a null.

  Parameters:
    `cellnum` - 0 based column number
  Returns:
    HSSFCell representing that column or null if undefined.

### getFirstCellNum

    public short getFirstCellNum()

  get the number of the first cell contained in this row.

  Returns:
    short representing the first logical cell in the row

### getLastCellNum

    public short getLastCellNum()

  get the number of the last cell contained in this row.

  Returns:
    short representing the last logical cell in the row

### getPhysicalNumberOfCells

    public int getPhysicalNumberOfCells()

  gets the number of defined cells (NOT number of cells in the actual row!). That is to say if only columns 0,4,5 have values then there would be 3.

  Returns:
    int representing the number of defined cells in the row.

### setHeight

    public void setHeight(short height)

  set the row's height or set to ff (-1) for undefined/default-height. Set the height in "twips" or 1/20th of a point.

  Parameters:
    `height` - rowheight or 0xff for undefined (use sheet default)

### setHeightInPoints

    public void setHeightInPoints(float height)

  set the row's height in points.

  Parameters:
    `height` - row height in points

### getHeight

    public short getHeight()

  get the row's height or ff (-1) for undefined/default-height in twips (1/20th of a point)

  Returns:
    rowheight or 0xff for undefined (use sheet default)

### getHeightInPoints

    public float getHeightInPoints()

  get the row's height or ff (-1) for undefined/default-height in points (20*getHeight())

  Returns:
    rowheight or 0xff for undefined (use sheet default)

### getRowRecord

    protected RowRecord getRowRecord()

  get the lowlevel RowRecord represented by this object - should only be called by other parts of the high level API

  Returns:
    RowRecord this row represents

### cellIterator

    public java.util.Iterator cellIterator()

  Returns:
    cell iterator of the physically defined cells. Note element 4 may actually be row cell depending on how many are defined!

### compareTo

    public int compareTo(java.lang.Object obj)

  Specified by:
    `compareTo` in interface `java.lang.Comparable`

### equals

    public boolean equals(java.lang.Object obj)

Copyright © 2003 Apache Software Foundation.